package CompileZ;

import java.io.*;
import org.jdom.*; 
import org.jdom.input.*;

/** 
 * Transllate the Z opeartors to JAVA code. 
 * @author  Slim KALLEL
 * @version 1.0 20-11-06
 */

class MappingPointCut{

	/*
	 *
	 * The method "getPointCut" return the corresponding PointCut according to the opeation (Operation) 
	 *
	 */
	
	String Operation;
	MappingPointCut(String op){
		Operation =op;
	}
	
	public static void main(String args[]){
		
		MappingPointCut pc = new MappingPointCut("InsertWriter");
		System.out.println(pc.getPointCut());
	}
	/**
	 * 
	 * @return
	 */
	public String getPointCut()
		{
			String result="";
			try{
				DOMBuilder builder = new DOMBuilder();
				Document doc = builder.build(new File("Mapping//Mapping.xml"));
				Element Mapp = doc.getRootElement();//Mapping
				Element[] PointCutRef = enfant(Mapp);//tous les pointcuts
					for(int j=0;j<PointCutRef.length;j++){
						if(PointCutRef[j].getAttributeValue("Reference").equals(Operation)){
							String pc=PointCutRef[j].getText();
							pc=pc.replace(", ",",");
							return (pc);
						}
					}
				
			}
			catch(Exception ex){System.out.println("MappingPointCut Exception ... " + ex );}
			return result;
			
		}
		

		Element[] enfant(Element e)
		{
			if (e.hasChildren())
			{
				java.util.List l=e.getChildren(); 
				Object fils_objet[]=l.toArray();  
				Element fils[]=new Element [fils_objet.length]; 
				for(int i=0;i<fils_objet.length;i++)
				{
					fils[i]=(Element)fils_objet[i];
				}
				return fils;
			}
			else return null;
		}
	
}